Subject: bug#65685: 29.1; Inconsistent behavior of quoted file name "/:~" across platforms

From: Jim Porter <[email-masked]>
Date: Mon, 9 Oct 2023 21:27:00 -0700

On 10/3/2023 4:22 AM, Michael Albinus wrote:
> I've played a little bit with file-name-non-special. The result is the
> appended patch, which expands always "/:~"  to the local home
> directory. Could you pls check whether it works for you?

Thanks for the patch. I tested this on GNU/Linux and MS-Windows, and it 
behaves as expected for local files, but Tramp filenames from MS-Windows 
to a remote GNU/Linux seem wrong (though they were wrong before this 
patch too).

Before the patch (on Emacs 29.1), if I open "/ssh:remote:/:~", then 
Emacs opens the file "/ssh:remote:/:/Users/Jim/AppData/Local/Temp/~".

After the patch, Emacs opens the file "/ssh:remote:/Users/Jim/Documents".

Based on the direction in your patch, I'd expect Emacs to open 
"/ssh:remote:/home/jim/".

(I imagine a similar issue could occur on a local GNU/Linux system, but 
going from a local MS-Windows to a remote GNU/Linux has the benefit that 
the two systems have obviously-different directory layouts.)